#include "Primitivas_CNICE.hpp"
#include "io.h"


#include <math.h>
#include <string.h>
#include <conio.h>
#include <dos.h>



//Variables globales
//La variable ESTADOS_SALIDAS almacena el estado de las 8 salidas digitales
//(activadas/desactivadas) mediante un nmero decimal
int ESTADO_SALIDAS = 0;

/*
******************************************************************************************************
************************** Primitivas para las SALIDAS DIGITALES *************************************
******************************************************************************************************
*
*
******************************************************************************************************
********* Procedimientos y funciones auxiliares de las primitivas de las SALIDAS DIGITALES ***********
*/



void SALIDA_DIGITAL(int dato)
/*Procedimiento auxiliar de las primitivas relacionadas con las salidas digitales
*Procedimiento que escribe en el puerto los datos necesarios para poder controlar
*las salidas digitales*/
{
  LoadIODLL();
  PortOut(0x37A,0x7);
  PortOut(0x378,(char)dato);
}//SALIDA_DIGITAL



void ACTIVA_SALIDA(int NumSalida)
/*Procedimiento auxiliar de las primitivas M1, M2, M3, M4 y CONECTA
*Procedimiento para activar la salida digital indicada en NumSalida dejando el
*resto de salidas como estn*/
{
  LoadIODLL();
  if ((NumSalida > 0) && (NumSalida < 9))
  {
    int SalidaTemporal;
    int Numero;
    SalidaTemporal = ESTADO_SALIDAS;
    Numero = NumSalida - 1;
    SalidaTemporal = ((SalidaTemporal) | ((int)pow (2,Numero)));
    SALIDA_DIGITAL (SalidaTemporal);
    ESTADO_SALIDAS = SalidaTemporal;

  }//if
}//ACTIVA_SALIDA



void DESACTIVA_SALIDA(int NumSalida)
/*Procedimiento auxiliar de las primitivas M1, M2, M3, M4, APAGA y DESCONECTA
*Procedimiento para desactivar la salida digital indicada en NumSalida dejando el
*resto de salidas digitales como estn*/
{
  LoadIODLL();
  if ((NumSalida > 0) && (NumSalida < 9))
  {
    int SalidaTemporal;
    int Numero;
    SalidaTemporal = ESTADO_SALIDAS;
    Numero = NumSalida - 1;
    SalidaTemporal = ((SalidaTemporal) & (255 - ((int)pow(2,Numero))));
    SALIDA_DIGITAL(SalidaTemporal);
    ESTADO_SALIDAS = SalidaTemporal;

  }//if
}//DESACTIVA_SALIDA


int estado_salida(int salidas, int sal)
//Funcin auxiliar de la primitiva M()
//Devuelve el estado de la salida (1 -activada-  0 -desactivada-)
//que se le indique en el parmetro sal
//El parmetro salidas indica el valor de las salidas digitales en conjunto
{
  int resultado;

  LoadIODLL();
  resultado = salidas & ((int)pow(2,(sal - 1)));
  if ( resultado )
  	 resultado = 1;
  else
    resultado = 0;

  return resultado;
}//estado_salida


char estado_motor(int salidas, int salI, int salD)
//Funcin auxiliar de las primitivas M, M_INT y CONECTADO_INT
//Devuelve el estado del motor (P, I o D) que est conectado a las salidas datI, datD
//El parmetro salidas indica el valor de las salidas digitales en conjunto
{
  int salidaI;
  int salidaD;
  char motor;

  LoadIODLL();
  salidaI = estado_salida(salidas, salI);
  salidaD = estado_salida(salidas, salD);
  switch (salidaI)
  {
      case 0:
          if (salidaD == 0)
             motor = 'P';
          else
             motor = 'D';
          break;
      case 1:
          if (salidaD == 1)
             motor = 'P';
          else
             motor = 'I';
          break;
      default:
          break;
  }//switch

  return motor;
}//estado_motor




/***************************************************************************************************/
extern "C"
void WINAPI segundos(float tiempo)
//Procedimiento que produce un retardo o espera tantos segundos como le indiquemos en
//el parmetro tiempo
{
  LoadIODLL();
  Sleep(tiempo);
}//segundos



/***************************************** PRIMITIVAS **********************************************/
extern "C"
void WINAPI M1(char dato)
//Procedimiento que hace girar o para un motor conectado a las salidas digitales S0-S1
{
  LoadIODLL();
  switch (dato)
  {
    case 'I':
      DESACTIVA_SALIDA (2);
      ACTIVA_SALIDA (1);
      break;
    case 'D':
      DESACTIVA_SALIDA (1);
      ACTIVA_SALIDA (2);
      break;
    case 'P':
    	DESACTIVA_SALIDA (1);
        DESACTIVA_SALIDA (2);
      break;
    default:
      break;
    }//switch
}//M1

extern "C"
void WINAPI M2(char dato)
//Procedimiento que hace girar o para un motor conectado a las salidas digitales S2-S3
{

  LoadIODLL();
  switch (dato)
  {
    case 'I':
      DESACTIVA_SALIDA (4);
      ACTIVA_SALIDA (3);
      break;
     case 'D':
      DESACTIVA_SALIDA (3);
      ACTIVA_SALIDA (4);
      break;
    case 'P':
    	DESACTIVA_SALIDA (3);
      DESACTIVA_SALIDA (4);
      break;
    default:
      break;
    }//switch
}//M2

extern "C"
void WINAPI M3(char dato)
//Procedimiento que hace girar o para un motor conectado a las salidas digitales S4-S5
{

  LoadIODLL();
  switch (dato)
  {
    case 'I':
      DESACTIVA_SALIDA (6);
      ACTIVA_SALIDA (5);
      break;
    case 'D':
      DESACTIVA_SALIDA (5);
      ACTIVA_SALIDA (6);
      break;
    case 'P':
    	DESACTIVA_SALIDA (5);
      DESACTIVA_SALIDA (6);
      break;
    default:
      break;
    }//switch
}//M3

extern "C"
void WINAPI M4(char dato)
//Procedimiento que hace girar o para un motor conectado a las salidas digitales S6-S7
{
  LoadIODLL();
  switch (dato)
  {
    case 'I':
      DESACTIVA_SALIDA (8);
      ACTIVA_SALIDA (7);
      break;
    case 'D':
      DESACTIVA_SALIDA (7);
      ACTIVA_SALIDA (8);
      break;
    case 'P':
    	DESACTIVA_SALIDA (7);
      DESACTIVA_SALIDA (8);
      break;
    default:
      break;
    }//switch
}//M4

extern "C"
void WINAPI M_INT(char* vector_motores)
//Procedimiento que rellena el vector de 4 elementos vector_motores con el estado de
//los 4 actuadores/motores (I, D o P)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//char vector_motores[4];
{
    LoadIODLL();
    int dato;
    dato = ESTADO_SALIDAS;
    for (int i=0;i<=3;i++)
	   vector_motores[i] = estado_motor(dato, (2*i)+1, (2*i)+2);
}//M_INT

extern "C"
void WINAPI M(const char* v_motores)
//Procedimiento que permite activar/desactivar todos los actuadores simultneamente.
//El parmetro v_motores tiene que ser un vector de 4 elementos
{
    LoadIODLL();
    char dato;
    dato = v_motores[0];
    M1(dato);
    dato = v_motores[1];
    M2(dato);
    dato = v_motores[2];
    M3(dato);
    dato = v_motores[3];
    M4(dato);
}//M

extern "C"
void WINAPI CONECTADO_INT(char* v_motores)
//Procedimiento que rellena el vector de 4 elementos v_motores con el estado de
//los 4 actuadores/motores (1 si el motor est activado  0 si est desactivado)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//char v_motores[4];
{
    int dato;

    LoadIODLL();
    dato = ESTADO_SALIDAS;
    for (int i = 0; i <= 3; i++ )
	    v_motores[i] = !( estado_motor(dato, (2*i)+1, (2*i)+2) == 'P' );
}//CONECTADO_INT


extern "C"
void WINAPI SALIDA(int num)
/*Procedimiento que controla individualmente o en conjunto cada una de las ocho salidas digitales
*Procedimiento que envia a las salidas digitales el nmero binario equivalente al decimal que pongamos en
*el parmetro num*/
{
  LoadIODLL();
  if ((num >= 0) && (num <= 255))
  {
     SALIDA_DIGITAL(num);
     ESTADO_SALIDAS = num;
  }//if
}//SALIDA

extern "C"
void WINAPI SALIDA_INT(int* v_salidas)
//Procedimiento que rellena el vector v_salidas con el estado de las ocho salidas digitales (1s  0s)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//int v_salidas[8];
{
  int dato;
  int sal;

  LoadIODLL();
  dato = ESTADO_SALIDAS;
  for (int i=1;i<=8;i++)
  {
    sal = i;
    v_salidas[i - 1] = estado_salida(dato, sal);
  }//for
}//SALIDA_INT


extern "C"
void WINAPI CONECTA(int num)
//Procedimiento que conecta la salida digital indicada en el nmero num y deja las dems como estn
{
  LoadIODLL();
  ACTIVA_SALIDA(num);
}//CONECTA

extern "C"
void WINAPI DESCONECTA(int num)
//Procedimiento que desconecta la salida digital indicada en el nmero num y deja las dems como estn
{
  LoadIODLL();
  DESACTIVA_SALIDA(num);
}//DESCONECTA

extern "C"
void WINAPI CONECTAR(void)
//Procedimiento que conecta TODAS las salidas digitales
{
  LoadIODLL();
  SALIDA(255);
}//CONECTAR

extern "C"
void WINAPI DESCONECTAR(void)
//Procedimiento que desconecta TODAS las salidas digitales
{
  LoadIODLL();
  SALIDA(0);
}//DESCONECTAR

extern "C"
int WINAPI VS_INT(void)
//Funcin que devuelve el estado de las ocho salidas digitales mediante un nmero decimal
{
  LoadIODLL();
  return ESTADO_SALIDAS;
}//VS_INT


/*
*************************************************************************************************************
****************************** Primitivas para las ENTRADAS DIGITALES ***************************************
*************************************************************************************************************
*/
extern "C"
int WINAPI VE_INT(void)
//Funcin que devuelve el estado de los ocho sensores digitales como un nmero decimal
//que es la suma de las entradas que toman valor 1
{
  int bajo;
  int alto;
  int dato;

  LoadIODLL();
  PortOut(0x37A, 0x3);
  bajo = PortIn(0x379);
  bajo = (bajo & 0x78) / 8;
  bajo = ~bajo;
  bajo = bajo & 15;

  PortOut(0x37A, 0x1);
  alto = PortIn(0x379);
  alto = (alto & 0x78) / 8;
  alto = ~alto;
  alto = alto & 15;
  dato = (alto * 16) | bajo;

  return dato;
}//VE_INT

extern "C"
int WINAPI SD(int entrada)
{
//Funcin que devuelve el valor (0  1) del sensor digital expresado en entrada (1, 2, ..., 8)
  int entradas;

  LoadIODLL();
  entradas = VE_INT();
  int resultado;
  resultado = ( ( (entradas) | (255 - (int)pow(2,(entrada - 1))) ) == 255);
  return resultado;
}//SD

extern "C"
void WINAPI SD_INT(int* v_entradas)
//Procedimiento que rellena el vector v_entradas con el estado de los ocho sensores digitales (0s  1s)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//int v_entradas[8];
{
  int entradas;

  LoadIODLL();
  entradas = VE_INT();
  for(int i=0;i<=7;i++)
     v_entradas[i] = ((int)pow(2,i) == (entradas & (int)pow(2,i)) );
}//SD_INT

extern "C"
void WINAPI EsperaOn(int entrada)
//Procedimiento que deja parado el programa esperando a que se active la entrada digital especificada
//en el parmetro entrada, el cual debe ser un nmero entre 1 y 8.
//Si entrada est activada o se activa, el programa sigue su curso.
{
  LoadIODLL();
  if ((entrada >= 1) && (entrada <= 8))
  {
    while (SD(entrada) == 0)
    {
       Sleep(0.5);
    }//while
  }//if
}//EsperaOn

extern "C"
void WINAPI EsperaOff(int entrada)
//Procedimiento que deja parado el programa esperando a que se desactive la entrada digital especificada
//en el parmetro entrada, el cual debe ser un nmero entre 1 y 8.
//Si entrada est desactivada o se desactiva, el programa sigue su curso.
{
  LoadIODLL();
  if ((entrada >= 1) && (entrada <= 8))
  {
    while (SD(entrada) == 1)
    {
      Sleep(0.5);
    }//while
  }//if
}//EsperaOff



/*
****************************************************************************************************
*********************** Primitivas para las ENTRADAS ANALGICAS*************************************
****************************************************************************************************
*/

/*
****************************************************************************************************
******* Procedimientos y funciones auxiliares de las primitivas de las ENTRADAS ANALGICAS *********
*/
int leer_entrada_analogica_num(int selecc)
//Funcin auxiliar de las primitivas
//Funcin que lee el valor decimal de la entrada analgica que indica selecc
//selecc = 1 ==> entrada 1
//selecc = 2 ==> entrada 2
//selecc = 4 ==> entrada 3
//selecc = 8 ==> entrada 4
{
  LoadIODLL();
  int bajo;
  int alto;
  int dato;
  PortOut(0x37A, 5);
  PortOut(0x378, (char)selecc);
  PortOut(0x37A, 8);
  PortOut(0x37A, 2);
  segundos(0.5);

  bajo = PortIn(0x379);
  bajo = (bajo & 0x78) / 8;
  bajo = bajo & 15;

  PortOut(0x37A, 5);
  PortOut(0x378, (char)selecc);
  PortOut(0x37A, 8);
  PortOut(0x37A, 0);
  segundos (0.5);

  alto = PortIn(0x379);
  alto = (alto & 0x78) / 8;
  alto = alto & 15;
  dato = (alto * 16) | bajo;

  return dato;
}//leer_entrada_analogica_num


int tension_de_entrada_analogica(int canal)
/*Funcin auxiliar de las primitivas
*Funcin para convertir el valor decimal leido en una entrada analgica en un valor de tensin
*CANAL = 1 ==> entrada 1
*CANAL = 2 ==> entrada 2
*CANAL = 4 ==> entrada 3
*CANAL = 8 ==> entrada 4*/
{
  LoadIODLL();
  int dato;
  dato = leer_entrada_analogica_num(canal);
  dato = dato * 5;
  dato = dato / 256;

  return dato;
}



//******************************** PRIMITIVAS ***************************************

extern "C"
int WINAPI SAW(void)
//Funcin que lee la entrada analgica 1 (IN0) y presenta su valor en voltios
{
  LoadIODLL();
  return tension_de_entrada_analogica(1);
}//SAW

extern "C"
int WINAPI SAX(void)
//Funcin que lee la entrada analgica 2 (IN1) y presenta su valor en voltios
{
  LoadIODLL();
  return tension_de_entrada_analogica(2);
}//SAX

extern "C"
int WINAPI SAY(void)
//Funcin que lee la entrada analgica 3 (IN2) y presenta su valor en voltios
{
  LoadIODLL();
  return tension_de_entrada_analogica(4);
}//SAY

extern "C"
int WINAPI SAZ(void)
//Funcin que lee la entrada analgica 4 (IN3) y presenta su valor en voltios
{
  LoadIODLL();
  return tension_de_entrada_analogica(8);
}//SAZ

extern "C"
void WINAPI SA_INT(int* v_analogicas)
//Procedimiento que rellena el vector v_analogicas con el valor (voltios) de los 4 sensores analgicos
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//int v_analogicas[4];
{
  LoadIODLL();
  for (int i=0;i<=3;i++)
  {
        v_analogicas[i] = tension_de_entrada_analogica(pow(2,i));
  }//for
}//SA_INT



/*
*************************************************************************************************************
*********** Primitivas para la compatibilidad con las primitivas proporcionadas por ENCONOR *****************
*************************************************************************************************************
*/

extern "C"
void WINAPI APAGA(int n)
//Procedimiento para la compatibilidad con las primitivas proporcionadas por ENCONOR
//Procedimiento que desconecta la salida digital que se le indique en el parmetro n, dejando el resto de
//salidas digitales como estn
{
  LoadIODLL();
  DESACTIVA_SALIDA(n);
}//APAGA

extern "C"
void WINAPI EnviaOcteto(int dato)
//Procedimiento para la compatibilidad con las primitivas proporcionadas por ENCONOR
//Procedimiento que envia a las salidas digitales el nmero binario equivalente al decimal que pongamos en
//el parmetro dato
{
  LoadIODLL();
  SALIDA(dato);
}//EnviaOcteto


extern "C"
bool WINAPI entrada(int n)
//Funcin para la compatibilidad con las primitivas proporcionadas por ENCONOR
//Funcin que devuelve TRUE si la entrada digital indicada en n est conectada o FALSE en caso contrario
{
   bool resultado;

   LoadIODLL();
   resultado = SD(n);
   if (resultado)
     return true;
   else
     return false;
}//entrada

extern "C"
int WINAPI leeanalogica(int dato)
//Funcin para la compatibilidad con las primitivas proporcionadas por ENCONOR
//Funcin que devuelve el valor de 8 bits de la entrada analgica especificada en el nmero
//dato (1, 2, 3  4). El valor devuelto oscila entre 0 y 255
{
  int resultado = 0;

  LoadIODLL();
  if ((dato >= 1) && (dato <= 4))
  {
    resultado = leer_entrada_analogica_num(dato);

  }//if
  return resultado;
}//leeanalogica





/*
**************************************************************************************************************
**************************************************************************************************************
*/
