#ifndef _PRIMITIVAS_CNICE_HPP_
#define _PRIMITIVAS_CNICE_HPP_

#include "windows.h"

#ifdef __cplusplus
extern "C" {
#endif



void WINAPI segundos(float tiempo);
//Procedimiento que produce un retardo o espera tantos segundos como le indiquemos en
//el parmetro tiempo


//**************************************** Primitivas para las SALIDAS DIGITALES **************************************
void WINAPI M1(char dato);
//Procedimiento que hace girar o para un motor conectado a las salidas digitales S0-S1
//Las llamadas deben ser del tipo:
//    M1('I');
//    M1('P');
void WINAPI M2(char dato);
void WINAPI M3(char dato);
void WINAPI M4(char dato);

void WINAPI M_INT(char* vector_motores);
//Procedimiento que rellena el vector de 4 elementos vector_motores con el estado de los 4 actuadores/motores (I, D o P)
//Para emplear este procedimiento se debe haber reservado primero memoria para el vector:
//    char vector_motores[4];
//    M_INT((char*)vector_motores);

void WINAPI M(const char* v_motores);
//Procedimiento que permite activar/desactivar todos los actuadores simultneamente.
//El parmetro v_motores tiene que ser un vector de 4 elementos:
//    char vector_motores[4];
//    v_motores[0] = 'I'; v_motores[1] = 'D';  v_motores[2] = 'P'; v_motores[3] = 'P';
//    M((char*)v_motores);

void WINAPI CONECTADO_INT(char* v_motores);
//Procedimiento que rellena el vector de 4 elementos v_motores con el estado de
//los 4 actuadores/motores (1 si el motor est activado  0 si est desactivado)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//    char v_motores[4];
//    CONECTADO_INT((char*)v_motores);

void WINAPI SALIDA(int num);

void WINAPI SALIDA_INT(int* v_salidas);
//Procedimiento que rellena el vector v_salidas con el estado de las ocho salidas digitales (1s  0s)
//Para emplear este procedimiento se debe haber reservado memoria para el valor devuelto:
//    int v_salidas[8];
//    SALIDA_INT((int*)v_salidas);

void WINAPI CONECTA(int num);

void WINAPI DESCONECTA(int num);

void WINAPI CONECTAR(void);

void WINAPI DESCONECTAR(void);

int WINAPI VS_INT(void);



//**************************************** Primitivas para las ENTRADAS DIGITALES **************************************
int WINAPI VE_INT(void);

int WINAPI SD(int entrada);

void WINAPI SD_INT(int* v_entradas);
//Procedimiento que rellena el vector v_entradas con el estado de los ocho sensores digitales (0s  1s)
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//   int v_entradas[8];
//   SD_INT((int*)v_entradas);

void WINAPI EsperaOn(int entrada);

void WINAPI EsperaOff(int entrada);




//*************************************** Primitivas para las ENTRADAS ANALGICAS **************************************
int WINAPI SAW(void);
int WINAPI SAX(void);
int WINAPI SAY(void);
int WINAPI SAZ(void);

void WINAPI SA_INT(int* v_analogicas);
//Procedimiento que rellena el vector v_analogicas con el valor (voltios) de los 4 sensores analgicos
//Para emplear este procedimiento se debe haber reservado memoria para
//el valor devuelto:
//   int v_analogicas[4];
//   SA_INT((int*)v_analogicas);







//************** Primitivas para la compatibilidad con las primitivas proporcionadas por ENCONOR ***********************
void WINAPI APAGA(int n);

void WINAPI EnviaOcteto(int dato);

bool WINAPI entrada(int n);

int WINAPI leeanalogica(int dato);

//**************************************************************************************************************
//**************************************************************************************************************
#ifdef __cplusplus
}
#endif

#endif



