/***************************************************
                    ASCENSOR
****************************************************/

#include <windows.h>
#include <stdio.h>
#include "io.h"
#include <string.h>
#include <stdlib.h>
#include <SDL.h>



HINSTANCE hInst;
WNDCLASSEX wincl2, wincl3;
HWND hwnd2, hwnd3;
HANDLE THandlei;

/*  Procedimiento de Ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WindowProcedureSinMemo (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WindowProcedureConMemo (HWND, UINT, WPARAM, LPARAM);

/*Declacion de funciones*/
void Escribir_Salidas_Digitales(int);
void encender(int);
void Espera(float);
int leedigital(int*, int*, int);

DWORD WINAPI Comprobar_Sensor_SinMemo(LPVOID parametros);
void Insertar(struct Cola **,struct Cola **,char);
void Borrar(struct Cola **,struct Cola **);
int EstaVacia(struct Cola *);

char szNombreClase[ ] = "Ascensor";
int motor=0, dato=0, lacabinasemueve;

/* Estructura de la cola que almacenara la secuencia de pisos pulsados*/
struct Cola{
 int Dato;
 struct Cola *Siguiente;
};

/*Funcion que comprueba si la cola esta o no vacia*/
int EstaVacia(struct Cola *Cabecera)
{
 if(Cabecera==NULL)
  return 1;
 else
  return 0;
}

/*Funcion que inserta un elemento en la cola*/
void Insertar(struct Cola **Cabecera,struct Cola **cola,int valor)
{
 struct Cola *Nuevo;
 Nuevo=(struct Cola *)malloc(sizeof(int));
  if(Nuevo!=NULL){
   Nuevo->Dato=valor;
   Nuevo->Siguiente=NULL;
   if(EstaVacia(*Cabecera))
	*Cabecera=Nuevo;
   else
	(*cola)->Siguiente=Nuevo;

   *cola=Nuevo;
  }
  else MessageBox(0,"No hay espacio suficiente en la cola","",1);
}

/*Funcion que borra el primer elemento de la cola*/
void Borrar(struct Cola **Cabecera,struct Cola **cola)
{
 int valor;
 struct Cola *Temporal;
 valor=(*Cabecera)->Dato;
 Temporal= *Cabecera;
 *Cabecera=(*Cabecera)->Siguiente;
 if(*Cabecera==NULL)
  *cola=NULL;
 free(Temporal);
}


/* Funcion que lee las entradas digitales de la controladora */
int leedigital(int *b, int *a, int d)
{

     LoadIODLL();
     PortOut(0x37A,0x3);
     *b = PortIn(0x379);
     PortOut(0x37A,0x1);
     *a = PortIn(0x379);
     
     *b = (*b & 0x78)/8;
     *b = ~*b;
     *b = *b & 15;
     
     *a = (*a & 0x78)/8;
     *a = ~*a;
     *a = *a & 15;
     d = (*a * 16) | *b; 
     return d;  
}

/* Funcin que comprueba el estado de los sensores y cambia el estado del motor.
Llama a la funcion que lee las entradas digitales*/
DWORD WINAPI Comprobar_Sensor(LPVOID parametros)
{
    int E, destinocabina;
    struct Cola *Cabecera,*cola;
    SDL_Surface *primera, *segunda, *tercera;
    SDL_Surface *screen;
    SDL_Rect destino;
    SDL_Rect rect;
    Cabecera=NULL;
    cola=NULL;
     int b = 4,a=5, d;
    
     for(;;){        
         E = leedigital(&b, &a, d);
         switch (E)
         {
                case 1:
                case 17:
                case 33:
                     if(dato==0){
                         if(lacabinasemueve==0){
                             destinocabina=1;
                             motor=1;
                             lacabinasemueve=1;
                             encender(motor);
                         }
                     }
                     else if (dato==1){
                          Insertar(&Cabecera,&cola,1);
                          Sleep(100);  
                     }
                     break;
                case 2:
                case 10:
                case 34:
                     if(dato==0){
                       if(lacabinasemueve==0){
                         if(destinocabina==1){
                             destinocabina=2;
                             motor=2;
                             lacabinasemueve=1;
                             encender(motor);
                         }
                         else if(destinocabina==3){
                             destinocabina=2;
                             motor=1;
                             lacabinasemueve=1;
                             encender(motor);
                         }
                       }
                     }
                     else if (dato==1){
                          Insertar(&Cabecera,&cola,2);  
                          Sleep(100);
                     }                
                     break;
                case 4:
                case 20:
                case 12:
                    if(dato==0){
                    if(lacabinasemueve==0){
                         destinocabina=3;    
                         motor=2;
                         lacabinasemueve=1;
                         encender(motor);
                     }
                     }else if (dato==1){
                          Insertar(&Cabecera,&cola,3);
                          Sleep(100);     
                     }
                     break;
                case 8:
                     if(destinocabina==1){
                        /*Se muestra la imagen de la cabina en el primer piso*/
                        primera = SDL_LoadBMP("ascensor1.bmp");
                        screen = SDL_SetVideoMode( 200, 308, 0, SDL_NOFRAME );
                        if( screen == NULL ) {
                               printf( "Error al entrar a modo grafico: %s\n", SDL_GetError() );
                               SDL_Quit();
                               //return -1;
                        }                       
                        rect = (SDL_Rect) {0, 0, 200, 200};
                        //SDL_LockSurface(screen);
                        SDL_BlitSurface(primera, NULL,screen,&rect);
                        SDL_Flip(screen);                  
                        encender(0); 
                        lacabinasemueve=0;                    
                     }
                     break;
                case 16:
                     if(destinocabina==2){
                     /*Se muestra la imagen de la cabina en el segundo piso*/
                        segunda = SDL_LoadBMP("ascensor2.bmp");
                        screen = SDL_SetVideoMode( 200, 308, 0, SDL_NOFRAME );
                        if( screen == NULL ) {
                            printf( "Error al entrar a modo grafico: %s\n", SDL_GetError() );
                            SDL_Quit();
                            //return -1;
                        }                       
                        rect = (SDL_Rect) {0, 0, 200, 200};
                        //SDL_LockSurface(screen);
                        SDL_BlitSurface(segunda, NULL,screen,&rect);
                        SDL_Flip(screen);
                        encender(0);         
                        lacabinasemueve=0;            
                     }
                     break;
                case 32:
                     if(destinocabina==3){
                     /*Se muestra la imagen de la cabina en el tercer piso*/
                        tercera = SDL_LoadBMP("ascensor3.bmp");
                        screen = SDL_SetVideoMode( 200, 308, 0, SDL_NOFRAME );
                        if( screen == NULL ) {
                               printf( "Error al entrar a modo grafico: %s\n", SDL_GetError() );
                               SDL_Quit();
                               //return -1;
                        }                       
                        rect = (SDL_Rect) {0, 0, 200, 200};
                        //SDL_LockSurface(screen);
                        SDL_BlitSurface(tercera, NULL,screen,&rect);
                        SDL_Flip(screen);
                        encender(0);     
                        lacabinasemueve=0;                
                     }
                     break;
                default:                       
                     break;
        }
   if(dato==1){
   if(!EstaVacia(Cabecera)){   /*Se comprueba que la cola no este vacia*/         
       if(lacabinasemueve==0){
               switch (Cabecera->Dato){ 
                     case 1:
                         Borrar(&Cabecera,&cola);
                         Sleep(1000);
                         destinocabina=1;
                         lacabinasemueve=1;
                         encender(1);
                         
                         break;
                     case 2:
                         Borrar(&Cabecera,&cola);
                         Sleep(1000);
                         if(destinocabina==1){
                             destinocabina=2;
                             lacabinasemueve=1;
                             encender(2);                             
                         }
                         else if(destinocabina==3){
                             destinocabina=2;
                             lacabinasemueve=1;
                             encender(1);                             
                         }
                         break;
                      case 3:
                         Borrar(&Cabecera,&cola);
                         Sleep(1000);
                         destinocabina=3;
                         lacabinasemueve=1;
                         encender(2);                         
                         break;
                      default:
                              break;
               }                        
       }}
     }
   }
   
}


int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hwnd;               /* Manipulador de Ventana */
    MSG messages;            /* Mensajes recibidos por la aplicacion */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase ventana */
    HINSTANCE hThisInstance2, hThisInstance3;
    DWORD TIdi, res;
    HANDLE Hilo_Control;
    
	       
    /* Estructura de la Ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szNombreClase;
    wincl.lpfnWndProc = WindowProcedure;      /* Funcion invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Uso de icono y de puntero por defecto */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* Sin menu */
    wincl.cbClsExtra = 0;                      /* Sin informacion adicional */
    wincl.cbWndExtra = 0;                      /* para la clase o la ventana*/
    /* Uso del color de fondo por defecto para la ventana */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
    
    wincl2.hInstance = hThisInstance2; 
    wincl2.lpszClassName = szNombreClase; 
    wincl2.lpfnWndProc = WindowProcedureSinMemo; /* Esta funcin es invocada por Windows */ 
    wincl2.style = CS_DBLCLKS; /* Captura los doble-clicks */ 
    wincl2.cbSize = sizeof (WNDCLASSEX);
     
    /* Usar icono y puntero por defector */ 
    wincl2.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl2.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl2.hCursor = LoadCursor (NULL, IDC_ARROW); 
    wincl2.lpszMenuName = NULL; /* Sin men */
    wincl2.cbClsExtra = 0; /* Sin informacin adicional para la */ 
    wincl2.cbWndExtra = 0; /* clase o la ventana */
    
    wincl2.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    wincl3.hInstance = hThisInstance3; 
    wincl3.lpszClassName = szNombreClase; 
    wincl3.lpfnWndProc = WindowProcedureConMemo; /* Esta funcin es invocada por Windows */ 
    wincl3.style = CS_DBLCLKS; /* Captura los doble-clicks */ 
    wincl3.cbSize = sizeof (WNDCLASSEX);
     
    /* Usar icono y puntero por defector */ 
    wincl3.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl3.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl3.hCursor = LoadCursor (NULL, IDC_ARROW); 
    wincl3.lpszMenuName = NULL; /* Sin men */
    wincl3.cbClsExtra = 0; /* Sin informacin adicional para la */ 
    wincl3.cbWndExtra = 0; /* clase o la ventana */
    
    wincl3.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    
    /* Registrar la clase de ventana, si falla, salir del programa */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* Crea la ventana, la clase esta registrada*/
    hwnd = CreateWindowEx (
           0,                   /* posibilidades de variacion */
           szNombreClase,       /* Nombre de la Clase */
           "Ascensor",           /* Titulo de la Ventana */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Posicion por defecto de Windows */
           CW_USEDEFAULT,       /* Posicion por defecto de Windows*/
           370,                 /* Ancho */
           200,                 /* Alto */
           HWND_DESKTOP,        /* Ventana hija del escritorio */
           NULL,                /* Sin Menu */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacion de ventana */
           );
  
     if (!RegisterClassEx (&wincl2))
        return 0;
        
     hwnd2= CreateWindowEx(
            0, /* Posibilidades de variacin */ 
            szNombreClase, /* Nombre de la clase */ 
            "Sin Memoria", /* Texto del ttulo */ 
            WS_OVERLAPPEDWINDOW, /* Tipo por defecto */ 
            CW_USEDEFAULT, /* Windows decide la posicin */ 
            CW_USEDEFAULT, /* donde se coloca la ventana */ 
            370, /* Ancho */ 
            200, /* Alto en pixels */ 
            hwnd, /* La ventana es hija del escritorio */ 
            NULL, /* Sin men */ 
            hThisInstance2, /* Manipulador de instancia */ 
            NULL /* No hay datos de creacin de ventana */ 
            );
            
     /* Registrar la clase de ventana, si falla, salir del programa */
     if (!RegisterClassEx (&wincl3))
        return 0;
           
     hwnd3= CreateWindowEx(
            0, /* Posibilidades de variacin */ 
            szNombreClase, /* Nombre de la clase */ 
            "Con Memoria", /* Texto del ttulo */ 
            WS_OVERLAPPEDWINDOW, /* Tipo por defecto */ 
            CW_USEDEFAULT, /* Windows decide la posicin */ 
            CW_USEDEFAULT, /* donde se coloca la ventana */ 
            370, /* Ancho */ 
            200, /* Alto en pixels */ 
            hwnd, /* La ventana es hija del escritorio */ 
            NULL, /* Sin men */ 
            hThisInstance3, /* Manipulador de instancia */ 
            NULL /* No hay datos de creacin de ventana */ 
            );       
  
    /* Mostrar la ventana */
    ShowWindow (hwnd, nFunsterStil);
    if (SDL_Init(SDL_INIT_VIDEO) < 0) {
       printf("No se pudo inicializar SDL: %s\n", SDL_GetError());
       exit(1);    
    }
    
    Hilo_Control=CreateThread(NULL, 0, Comprobar_Sensor, 0,0, NULL);
	if (Hilo_Control==NULL)
	{
		MessageBox(0,"Error al crear el hilo","Welcome Message",1); 
		exit(0);
    }
    
    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE*/
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&messages);
        /* Enviar el mensaje al procedimiento de la ventana */
        DispatchMessage(&messages);
    }

    /* Salir con valor de retorno */
    SDL_Quit();
    return messages.wParam;
    CloseHandle(Hilo_Control);
    
}


/*  Esta funcion es invocada por la funcion DispatchMessage() */
/*  Esta funcion muestra la ventana principal del ascensor con los botones 
    que permiten elegir la opcion de usar memoria o no */ 
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
        
    HWND hwndboton1, hwndboton2, hwndboton3;
    SDL_Surface *primera1;
    SDL_Surface *screen;
    SDL_Rect destino;      
    switch (message) /* Manipulador del mensaje */
    {
        // Creacin de los botones Manual, Automatico y Salir   
        case WM_CREATE:
            hwndboton1 = CreateWindow("button", "Sin Memoria",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              10, 30, 150, 40,
              hwnd, (HMENU) 1, hInst, NULL);
            hwndboton2 = CreateWindow("button", "Con Memoria",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              200, 30, 150, 40,
              hwnd, (HMENU) 2, hInst, NULL);
            hwndboton3 = CreateWindow("button", "Salir",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              100, 100, 150, 40,
              hwnd, (HMENU) 3, hInst, NULL);
              
            /*Se muestra la imagen del ascensor en la primera planta*/
            primera1 = SDL_LoadBMP("ascensor1.bmp");
            screen = SDL_SetVideoMode(200, 308, 0, SDL_NOFRAME );
            if( screen == NULL ) {
                printf( "Error al entrar a modo grafico: %s\n", SDL_GetError() );
                SDL_Quit();
                return -1;
            } 
            SDL_Rect rect;
            rect = (SDL_Rect) {0, 0, 200, 200};
            //SDL_LockSurface(screen);
            SDL_BlitSurface(primera1, NULL,screen,&rect);
            SDL_Flip(screen);
            return 0;
        
        //Eventos al pulsar cada uno de los botones
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case 1:  // botn Sin Memoria
                     ShowWindow(hwnd2,1);
                     break;
                case 2:  // botn Con Memoria
                     ShowWindow(hwnd3,1);
                     break;
                case 3:  // botn Salir
                     motor = 0;
                     encender(motor);
                     SendMessage(hwnd, WM_CLOSE, 0, 0);
                     break;
                default:
                        break;
            }
            return 0;
           
        case WM_DESTROY:
            PostQuitMessage (0);       /* envia un mensaje WM_QUIT a la cola de mensajes*/
            break;
        default:                      /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


/*Funcion que muestra en entorno grafico del ascensor en la opcion del 
  funcionamiento sin memoria*/
LRESULT CALLBACK WindowProcedureSinMemo (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
        
    HWND hwndboton1, hwndboton2, hwndboton3;
    int i=1, valor;
    HANDLE Hilo_Control;
 
    switch (message) /* Manipulador del mensaje */
    {
        // Creacin de los botones    
        case WM_CREATE:
            hwndboton1 = CreateWindow("button", "Activar",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              10, 30, 150, 40,
              hwnd, (HMENU) 1, ((LPCREATESTRUCT) lParam)->hInstance, NULL);
            hwndboton2 = CreateWindow("button", "Desactivar",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              200, 30, 150, 40,
              hwnd, (HMENU) 2, ((LPCREATESTRUCT) lParam)->hInstance, NULL);
            hwndboton3 = CreateWindow("button", "Volver",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              100, 100, 150, 40,
              hwnd, (HMENU) 3, ((LPCREATESTRUCT) lParam)->hInstance, NULL);
        return 0;
        
        //Eventos al pulsar cada uno de los botones
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case 1:  // botn Activar
                     dato=0;
                     break;
                case 2:  // botn Desactivar
                     motor = 0;
                     dato=0;
                     lacabinasemueve=0;
                     encender(motor);
                     break;
                case 3:  // botn Salir
                     motor = 0;
                     dato=0;
                     lacabinasemueve=0;
                     encender(motor);
                     SendMessage(hwnd, WM_CLOSE, 0, 0);
                     break;
    
                default:
                        break;
            }
            return 0;
        case WM_CLOSE:
             ShowWindow(hwnd, 0);
             break;
        case WM_DESTROY:
            PostQuitMessage (0);       /* envia un mensaje WM_QUIT a la cola de mensajes*/
            break;
        default:                      /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


/*Funcion que muestra el entorno grafico del ascensor en la opcion de 
  funcionamiento con memoria*/
LRESULT CALLBACK WindowProcedureConMemo (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
        
    HWND hwndboton1, hwndboton2, hwndboton3;
    DWORD dwGenericThread, evento;
    HANDLE Hilo_Control2;
    int i=1, valor;
 
    switch (message) /* Manipulador del mensaje */
    {
        // Creacin de los botones SubirBarrera, BajarBarrera, Parar, Volver   
        case WM_CREATE:
            hwndboton1 = CreateWindow("button", "Activar",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              10, 30, 150, 40,
              hwnd, (HMENU) 1, hInst, NULL);
            hwndboton2 = CreateWindow("button", "Desactivar",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              200, 30, 150, 40,
              hwnd, (HMENU) 2, hInst, NULL);
            hwndboton3 = CreateWindow("button", "Volver",
              WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
              100, 100, 150, 40,
              hwnd, (HMENU) 3, hInst, NULL);
        return 0;
        
        //Eventos al pulsar cada uno de los botones
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case 1:  // botn Activar
                     dato=1;
                     break;
                case 2:  // botn Desactivar
                     motor = 0;
                     dato=1;
                     lacabinasemueve=0;
                     encender(motor);
                     break;
                case 3:  // botn Volver
                     motor = 0;
                     dato=1;
                     lacabinasemueve=0;
                     encender(motor);
                     SendMessage(hwnd, WM_CLOSE, 0, 0);
                     break;
                default:
                        break;
            }
            return 0;
        case WM_CLOSE:
             ShowWindow(hwnd, 0);
             break;   
        case WM_DESTROY:
            PostQuitMessage (0);       /* envia un mensaje WM_QUIT a la cola de mensajes*/
            break;
        default:                      /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


/*Funcin que Activa las Salidas Digitales*/
void encender(int led)
{
    LoadIODLL();   //Carga la libreria io.dll
    PortOut(0x37A,0x7);
    PortOut(0x378,led);
}



